<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: OpenSim::DataQueue_&lt; T &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_user.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For MATLAB, Python, Java, and C++ users</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('classOpenSim_1_1DataQueue__.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="classOpenSim_1_1DataQueue__-members.html">List of all members</a> &#124;
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">OpenSim::DataQueue_&lt; T &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>DataQueue is a wrapper around the std::queue customized to handle data processing and synchronization, and limiting the interface to only the subset of operations needed for this use case.  
 <a href="classOpenSim_1_1DataQueue__.html#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:acdb22d1d71bb0913c6d561add67cb971"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1DataQueue__.html#acdb22d1d71bb0913c6d561add67cb971">~DataQueue_</a> ()</td></tr>
<tr class="separator:acdb22d1d71bb0913c6d561add67cb971"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7c9d1808517f9da9f7e70d1bd37c0551"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1DataQueue__.html#a7c9d1808517f9da9f7e70d1bd37c0551">DataQueue_</a> ()=default</td></tr>
<tr class="separator:a7c9d1808517f9da9f7e70d1bd37c0551"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a99f13b5405c6342385102bd68b6ad1d6"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1DataQueue__.html#a99f13b5405c6342385102bd68b6ad1d6">DataQueue_</a> (const <a class="el" href="classOpenSim_1_1DataQueue__.html">DataQueue_</a> &amp;other)</td></tr>
<tr class="separator:a99f13b5405c6342385102bd68b6ad1d6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a56a72e54c9d58e769e2e982eeea4d142"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1DataQueue__.html#a56a72e54c9d58e769e2e982eeea4d142">DataQueue_</a> (<a class="el" href="classOpenSim_1_1DataQueue__.html">DataQueue_</a> &amp;&amp;other)</td></tr>
<tr class="separator:a56a72e54c9d58e769e2e982eeea4d142"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a27466e030404372b240cf86472a40fcb"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOpenSim_1_1DataQueue__.html">DataQueue_</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1DataQueue__.html#a27466e030404372b240cf86472a40fcb">operator=</a> (const <a class="el" href="classOpenSim_1_1DataQueue__.html">DataQueue_</a> &amp;other)</td></tr>
<tr class="separator:a27466e030404372b240cf86472a40fcb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a672df1c38f48d688fde0f9adf05098ca"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1DataQueue__.html#a672df1c38f48d688fde0f9adf05098ca">push_back</a> (const double time, const SimTK::RowVectorView_&lt; T &gt; &amp;data)</td></tr>
<tr class="separator:a672df1c38f48d688fde0f9adf05098ca"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5d030a34c6650285a655b5bc6273723f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1DataQueue__.html#a5d030a34c6650285a655b5bc6273723f">pop_front</a> (double &amp;time, SimTK::RowVector_&lt; T &gt; &amp;data)</td></tr>
<tr class="separator:a5d030a34c6650285a655b5bc6273723f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acbc546508023d3724c4f34e6b8eab03b"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1DataQueue__.html#acbc546508023d3724c4f34e6b8eab03b">isEmpty</a> ()</td></tr>
<tr class="separator:acbc546508023d3724c4f34e6b8eab03b"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description </h2>
<div class="textblock"><h3>template&lt;class T&gt;<br />
class OpenSim::DataQueue_&lt; T &gt;</h3>

<p>DataQueue is a wrapper around the std::queue customized to handle data processing and synchronization, and limiting the interface to only the subset of operations needed for this use case. </p>
<p>Synchronization is experimental as of now. Client is responsible for making sure order is preserved. timestamp is required to pass in data so that clients can enforce order, however timestamp is not used/order-enforced internally. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="acdb22d1d71bb0913c6d561add67cb971"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acdb22d1d71bb0913c6d561add67cb971">&#9670;&nbsp;</a></span>~DataQueue_()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOpenSim_1_1DataQueue__.html">OpenSim::DataQueue_</a>&lt; T &gt;::~<a class="el" href="classOpenSim_1_1DataQueue__.html">DataQueue_</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a7c9d1808517f9da9f7e70d1bd37c0551"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7c9d1808517f9da9f7e70d1bd37c0551">&#9670;&nbsp;</a></span>DataQueue_() <span class="overload">[1/3]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1DataQueue__.html">OpenSim::DataQueue_</a>&lt; T &gt;::<a class="el" href="classOpenSim_1_1DataQueue__.html">DataQueue_</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">default</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a99f13b5405c6342385102bd68b6ad1d6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a99f13b5405c6342385102bd68b6ad1d6">&#9670;&nbsp;</a></span>DataQueue_() <span class="overload">[2/3]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1DataQueue__.html">OpenSim::DataQueue_</a>&lt; T &gt;::<a class="el" href="classOpenSim_1_1DataQueue__.html">DataQueue_</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1DataQueue__.html">DataQueue_</a>&lt; T &gt; &amp;&#160;</td>
          <td class="paramname"><em>other</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a56a72e54c9d58e769e2e982eeea4d142"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a56a72e54c9d58e769e2e982eeea4d142">&#9670;&nbsp;</a></span>DataQueue_() <span class="overload">[3/3]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1DataQueue__.html">OpenSim::DataQueue_</a>&lt; T &gt;::<a class="el" href="classOpenSim_1_1DataQueue__.html">DataQueue_</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOpenSim_1_1DataQueue__.html">DataQueue_</a>&lt; T &gt; &amp;&amp;&#160;</td>
          <td class="paramname"><em>other</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="acbc546508023d3724c4f34e6b8eab03b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acbc546508023d3724c4f34e6b8eab03b">&#9670;&nbsp;</a></span>isEmpty()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOpenSim_1_1DataQueue__.html">OpenSim::DataQueue_</a>&lt; T &gt;::isEmpty </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a27466e030404372b240cf86472a40fcb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a27466e030404372b240cf86472a40fcb">&#9670;&nbsp;</a></span>operator=()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1DataQueue__.html">DataQueue_</a>&amp; <a class="el" href="classOpenSim_1_1DataQueue__.html">OpenSim::DataQueue_</a>&lt; T &gt;::operator= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1DataQueue__.html">DataQueue_</a>&lt; T &gt; &amp;&#160;</td>
          <td class="paramname"><em>other</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a5d030a34c6650285a655b5bc6273723f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5d030a34c6650285a655b5bc6273723f">&#9670;&nbsp;</a></span>pop_front()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1DataQueue__.html">OpenSim::DataQueue_</a>&lt; T &gt;::pop_front </td>
          <td>(</td>
          <td class="paramtype">double &amp;&#160;</td>
          <td class="paramname"><em>time</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">SimTK::RowVector_&lt; T &gt; &amp;&#160;</td>
          <td class="paramname"><em>data</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a672df1c38f48d688fde0f9adf05098ca"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a672df1c38f48d688fde0f9adf05098ca">&#9670;&nbsp;</a></span>push_back()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1DataQueue__.html">OpenSim::DataQueue_</a>&lt; T &gt;::push_back </td>
          <td>(</td>
          <td class="paramtype">const double&#160;</td>
          <td class="paramname"><em>time</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const SimTK::RowVectorView_&lt; T &gt; &amp;&#160;</td>
          <td class="paramname"><em>data</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>OpenSim/Common/DataQueue.h</li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespaceOpenSim.html">OpenSim</a></li><li class="navelem"><a class="el" href="classOpenSim_1_1DataQueue__.html">DataQueue_</a></li>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:43 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
